/*********************************************************************
 *  SPDX-License-Identifier: MIT                                     *
 *  Copyright (C) 2022-2023 by Helge Kortendieck  alan@kasmithee.de  *
 *                                                                   *
 *  This file is part of qaplay.                                     *
 *********************************************************************/

#ifndef _SETPLAYLIST_H_
#define _SETPLAYLIST_H_

#include <QDialog>
#include <QFileDialog>
#include <QFileInfo>
#include <QMessageBox>
#include <QString>
#include <QTimer>
#include <QWidget>

#include "ui_setplaylist.h"

#include "m3u.h"

#include <iostream>
using namespace std;


class SetPlayList : public QDialog
{
	Q_OBJECT

public:
	SetPlayList(QDialog* parent = 0);
		~SetPlayList();

private:
	bool bSplCreateNew;

	int iSplD;
	int iSplD2;

	QString sSplD;
	QString sSplFileFromDlg;
	QString sSplFileName;
	QString sSplFileNameOld;
	QString sSplFilePath;
	QString sSplFilePathName;
	QString sSplFilePathNameCalled;
//	QString sSplFilePathOld;

	QStringList slSplD;
	QStringList slDSl;		// song list struct entity

	Ui::wSetPlayList uiSpl;	// set playlist widget

	QDialog wSpl;			// set playlist widget

private slots:
	void splDlgClose();								// close dialog
	void splDlgPopPathName(const QString& sSplD2);	// set playlist path and name in dialog
	void splDlgSet();								// close dialog - set new m3u
	void splDlgShow(const QString& sSplD);			// show set playlist dialog

	void splFileCurChngd();							// current m3u changed
	void splFileNew();								// create new playlist to add files to
	int splFileNewCreate();							// physically create new playlist to add files to - 0=fail, 1=success
	void splFileOpen();								// open file dialog to pick an existing playlist to set
	void splFileRename();							// rename current playlist
	void splFileSaveAs();							// save current playlist under different name and start using it as such
	void splQmb(int iD);							// QMessageBox

	signals:
		void sigSplQapM3uUpd(const QString& sSplD);
		void sigSplQapDelete();
};

#endif
